## ccextractor-dmo 0.77

=== linux/Makefile ===
SHELL = /bin/sh

CC = gcc
SYS := $(shell gcc -dumpmachine)
CFLAGS = -O3 -std=gnu99
INCLUDE = -I../src/gpacmp4/ -I../src/libpng -I../src/zlib -I../src/lib_ccx -I../src/.
ALL_FLAGS = -Wno-write-strings -D_FILE_OFFSET_BITS=64
LDFLAGS = -lm

ifneq (, $(findstring linux, $(SYS)))
CFLAGS +=-DGPAC_CONFIG_LINUX
endif
TARGET = ccextractor

OBJS_DIR = objs
VPATH = ../src:../src/gpacmp4:../src/libpng:../src/zlib:../src/lib_ccx

SRCS_DIR = ../src
SRCS_C = $(wildcard $(SRCS_DIR)/*.c)
OBJS = $(SRCS_C:$(SRCS_DIR)/%.c=$(OBJS_DIR)/%.o)

SRCS_CCX_DIR = $(SRCS_DIR)/lib_ccx
SRCS_CCX = $(wildcard $(SRCS_CCX_DIR)/*.c)
OBJS_CCX = $(SRCS_CCX:$(SRCS_CCX_DIR)/%.c=$(OBJS_DIR)/%.o)

SRCS_PNG_DIR = $(SRCS_DIR)/libpng
SRCS_PNG = $(wildcard $(SRCS_PNG_DIR)/*.c)
OBJS_PNG = $(SRCS_PNG:$(SRCS_PNG_DIR)/%.c=$(OBJS_DIR)/%.o)

SRCS_GPACMP4_DIR = $(SRCS_DIR)/gpacmp4
SRCS_GPACMP4_C = $(wildcard $(SRCS_GPACMP4_DIR)/*.c)
SRCS_GPACMP4_CPP = $(wildcard $(SRCS_GPACMP4_DIR)/*.cpp)
OBJS_GPACMP4 = $(SRCS_GPACMP4_C:$(SRCS_GPACMP4_DIR)/%.c=$(OBJS_DIR)/%.o) \
			   $(SRCS_GPACMP4_CPP:$(SRCS_GPACMP4_DIR)/%.cpp=$(OBJS_DIR)/%.o)

SRCS_ZLIB_DIR = $(SRCS_DIR)/zlib
SRCS_ZLIB = $(wildcard $(SRCS_ZLIB_DIR)/*.c)
OBJS_ZLIB = $(SRCS_ZLIB:$(SRCS_ZLIB_DIR)/%.c=$(OBJS_DIR)/%.o)

INSTLALL = cp -f -p
INSTLALL_PROGRAM = $(INSTLALL)
DESTDIR = /usr/bin

ifeq ($(ENABLE_OCR),yes)
CFLAGS+=-DENABLE_OCR
TESS_LDFLAGS+= $(shell pkg-config --libs tesseract)
LEPT_LDFLAGS+= $(shell pkg-config --libs lept)

#error checking of library are there or not
ifeq ($(TESS_LDFLAGS),$(EMPTY))
$(error **ERROR** "tesseract not found")
else
#TODO print the version of library found
$(info  "tesseract found")
endif
ifeq ($(LEPT_LDFLAGS),$(EMPTY))
$(error **ERROR** "leptonica not found")
else
#TODO print the version of library found
$(info  "Leptonica found")
endif

CFLAGS  += $(shell pkg-config --cflags tesseract)
CFLAGS  += $(shell pkg-config --cflags lept)
LDFLAGS += $(TESS_LDFLAGS)
LDFLAGS += $(LEPT_LDFLAGS)
endif


ifeq ($(ENABLE_FFMPEG),yes)
CFLAGS+=-DENABLE_FFMPEG
CFLAGS+= $(shell pkg-config --cflags libavcodec)
CFLAGS+= $(shell pkg-config --cflags libavformat)
CFLAGS+= $(shell pkg-config --cflags libavutil)
LDFLAGS+= $(shell pkg-config --libs libavcodec )
LDFLAGS+= $(shell pkg-config --libs libavformat )
LDFLAGS+= $(shell pkg-config --libs libavutil )
endif

.PHONY: all
all: objs_dir $(TARGET) 

.PHONY: objs_dir
objs_dir: 
	mkdir -p $(OBJS_DIR)

$(TARGET): $(OBJS) $(OBJS_PNG) $(OBJS_GPACMP4) $(OBJS_ZLIB) $(OBJS_CCX)
	$(CC) $(ALL_FLAGS) $(CFLAGS) $(OBJS) $(OBJS_CCX) $(OBJS_PNG) $(OBJS_GPACMP4) $(OBJS_ZLIB) $(LDFLAGS) -o $@

$(OBJS_DIR)/%.o: %.c
	$(CC) -c $(ALL_FLAGS) $(INCLUDE) $(CFLAGS) $< -o $@  

$(OBJS_DIR)/%.o: %.cpp
	$(CC) -c $(ALL_FLAGS) $(INCLUDE) $(CFLAGS) $< -o $@ -I../src/gpacmp4 

$(OBJS_DIR)/ccextractor.o: ccextractor.c
	$(CC) -c $(ALL_FLAGS) $(INCLUDE) $(CFLAGS) -O0 $< -o $@  

.PHONY: clean
clean:
	rm -rf $(TARGET) 2>/dev/null || true
	rm -rf $(OBJS_CCX) $(OBJS_PNG) $(OBJS_ZLIB) $(OBJS_GPACMP4) $(OBJS) 2>/dev/null || true
	rm -rdf $(OBJS_DIR) 2>/dev/null || true
	rm -rf .depend 2>/dev/null || true

.PHONY: install
install: $(TARGET)
	$(INSTLALL_PROGRAM) $(TARGET) $(DESTDIR)

.PHONY: uninstall
uninstall: 
	rm -iv $(DESTDIR)/$(TARGET) 

.PHONY: depend dep
depend dep:
	$(CC) $(CFLAGS) $(INCLUDE) -E -MM $(SRCS_C) $(SRCS_PNG) $(SRCS_ZLIB) $(SRCS_CCX) \
		$(SRCS_GPACMP4_C) $(SRCS_GPACMP4_CPP) |\
		sed 's/^[a-zA-Z_0-9]*.o/$(OBJS_DIR)\/&/' > .depend

-include .depend

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0.2)

project (CCExtractor)

option (WITH_FFMPEG "Build using FFmpeg demuxer and decoder" OFF)
option (WITH_OCR "Build with OCR (Optical Character Recognition) feature" OFF)

#Version number
set (CCEXTRACTOR_VERSION_MAJOR 0)
set (CCEXTRACTOR_VERSION_MINOR 77)

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/CCExtractorConfig.h.in"
  "${PROJECT_BINARY_DIR}/CCExtractorConfig.h"
  )


include_directories ("${PROJECT_SOURCE_DIR}")
include_directories ("${PROJECT_SOURCE_DIR}/lib_ccx")
include_directories ("${PROJECT_SOURCE_DIR}/gpacmp4/")

#Adding some platform specific library path
link_directories (/opt/local/lib)
link_directories (/usr/local/lib)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0 -Wall -g -std=gnu99 -Wno-write-strings -D_FILE_OFFSET_BITS=64")
add_subdirectory (lib_ccx)

aux_source_directory (${PROJECT_SOURCE_DIR} SOURCEFILE)
set (EXTRA_LIBS ${EXTRA_LIBS} ccx)
set (EXTRA_LIBS ${EXTRA_LIBS} m)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
set (EXTRA_LIBS ${EXTRA_LIBS} iconv)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


find_package (PkgConfig)
if(PKG_CONFIG_FOUND)
  pkg_check_modules(PNG libpng )
  if(PNG_FOUND)
    set (EXTRA_LIBS ${EXTRA_LIBS} png)
  else (PNG_FOUND)
    include_directories ("${PROJECT_SOURCE_DIR}/libpng/")
    aux_source_directory ("${PROJECT_SOURCE_DIR}/libpng/" SOURCEFILE)
    aux_source_directory ("${PROJECT_SOURCE_DIR}/zlib/" SOURCEFILE)
  endif(PNG_FOUND)
endif (PKG_CONFIG_FOUND)

########################################################
# Build using FFmpeg libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_FFMPEG)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_STATIC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_STATIC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_STATIC_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)

########################################################
# Build with OCR using leptonica and tesseract libraries
########################################################

if (WITH_OCR)
  find_package(PkgConfig)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_STATIC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_STATIC_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR ${TESSERACT_CFLAGS} ${LEPTONICA_CFLAGS}")
endif (WITH_OCR)

add_executable (ccextractor ${SOURCEFILE})
target_link_libraries (ccextractor ${EXTRA_LIBS})

install (TARGETS ccextractor DESTINATION bin)

=== src/lib_ccx/CMakeLists.txt ===
cmake_policy (SET CMP0037 NEW)

set (CMAKE_C_FLAGS "-O0 -Wall -g -std=gnu99")

if (WITH_FFMPEG)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
endif (WITH_FFMPEG)

if (WITH_OCR)
  find_package(PkgConfig)

  pkg_check_modules(TESSERACT REQUIRED tesseract)
  pkg_check_modules(LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_STATIC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_STATIC_LIBRARIES})
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR ${TESSERACT_CFLAGS} ${LEPTONICA_CFLAGS}")
endif (WITH_OCR)

aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_ccx/" SOURCEFILE)
aux_source_directory ("${PROJECT_SOURCE_DIR}/gpacmp4/" SOURCEFILE)

add_library (ccx ${SOURCEFILE})

if (MINGW OR CYGWIN)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_WIN32")
endif (MINGW OR CYGWIN)

if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_LINUX")
endif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DGPAC_CONFIG_DARWIN")
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


file (GLOB HeaderFiles *.h)
file (WRITE ccx.pc "prefix=${CMAKE_INSTALL_PREFIX}\n"
                  "includedir=\${prefix}/include\n"
                  "libdir=\${prefix}/lib\n\n"
                  "Name: ccx\n"
                  "Description: Closed Caption Extraction library\n"
                  "Version: 0.75\n"
                  "Cflags: -I\${includedir}/\n"
                  "Libs: -L\${libdir} -lccx -lpng\n"
                  "Libs.private: -lpng\n"
                  )

install (TARGETS ccx DESTINATION lib)
install (FILES ${HeaderFiles} DESTINATION include)
install (FILES ccx.pc DESTINATION lib/pkgconfig)

## ccextractor-dmo 0.93

=== debian/changelog ===
ccextractor-dmo (1:0.93-dmo1+deb11u2) stable; urgency=medium

  * Build with libgpac-dev instead of included gpac.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 07 Oct 2021 16:53:13 +0200

ccextractor-dmo (1:0.93-dmo1+deb11u1) stable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 17 Aug 2021 08:02:19 +0200

ccextractor-dmo (1:0.92-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 11 Aug 2021 07:41:28 +0200

ccextractor-dmo (1:0.91-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 28 Jul 2021 09:49:12 +0200

ccextractor-dmo (1:0.90-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 14 Jul 2021 14:03:38 +0200

ccextractor-dmo (1:0.89+ds1-dmo1) unstable; urgency=medium

  * Remove more unneedded files from upstream source.
  * New patch to not remove debug symbols.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 15 Jun 2021 11:31:07 +0200

ccextractor-dmo (1:0.89-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 14 Jun 2021 09:06:37 +0200

ccextractor-dmo (1:0.88-dmo2) unstable; urgency=medium

  * Add upstream patch to fix build with gcc 10

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 23 Jul 2020 07:48:12 +0200

ccextractor-dmo (1:0.88-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 22 May 2019 09:10:58 +0200

ccextractor-dmo (1:0.87-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 24 Oct 2018 15:24:09 +0200

ccextractor-dmo (1:0.86-dmo2) unstable; urgency=medium

  * Use system libfreetype.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 25 Apr 2018 18:16:47 +0200

ccextractor-dmo (1:0.86-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 25 Apr 2018 09:59:17 +0200

ccextractor-dmo (0.85-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 04 Mar 2018 17:25:10 +0100

ccextractor-dmo (0.84-dmo2) unstable; urgency=medium

  * Rebuild against libtesseract4

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 19 Dec 2017 14:33:06 +0100

ccextractor-dmo (0.84-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 17 Dec 2016 08:54:36 +0100

ccextractor-dmo (0.83-dmo1) unstable; urgency=medium

  * New upstream release.
  * Use system libutf8proc library.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 15 Dec 2016 09:10:47 +0100

ccextractor-dmo (0.82-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 16 Aug 2016 08:39:52 +0200

ccextractor-dmo (0.81-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 21 Jun 2016 08:35:35 +0200

ccextractor-dmo (0.80-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 26 Apr 2016 14:58:05 +0200

ccextractor-dmo (0.79-dmo3) unstable; urgency=medium

  * Rebuild against libpng16

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 07 Apr 2016 13:44:51 +0200

ccextractor-dmo (0.79-dmo2) unstable; urgency=medium

  * Rebuild against liblept5

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 04 Feb 2016 18:50:42 +0100

ccextractor-dmo (0.79-dmo1) unstable; urgency=medium

  * New upstream bugfix release.
  * Build without ffmpeg support ( See
    https://github.com/CCExtractor/ccextractor/issues/258 )

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 13 Jan 2016 15:54:24 +0100

ccextractor-dmo (0.77-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 21 Jun 2015 08:46:40 +0200

ccextractor-dmo (0.76-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 28 Mar 2015 16:09:08 +0100

ccextractor-dmo (0.75-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 14 Jan 2015 10:12:27 +0100

ccextractor-dmo (0.74-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 24 Sep 2014 15:48:54 +0200

ccextractor-dmo (0.73-dmo3) unstable; urgency=medium

  * Rebuild against ffmpeg 2.4

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 16 Sep 2014 01:04:57 +0200

ccextractor-dmo (0.73-dmo2) unstable; urgency=medium

  * Enable ffmpeg support to add support for multiple encapsulator.
  * Enable OCR support with libtesseract.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 26 Aug 2014 08:37:03 +0200

ccextractor-dmo (0.73-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 20 Aug 2014 17:06:41 +0200

ccextractor-dmo (0.72-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 13 Aug 2014 13:16:26 +0200

ccextractor (0.71-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 04 Aug 2014 15:46:13 +0200

ccextractor (0.70-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 03 Aug 2014 18:05:38 +0200

ccextractor (0.69-dmo2) unstable; urgency=medium

  * Use (and modify) the included Makefile in linux directory.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 07 Apr 2014 07:49:42 +0200



=== debian/control ===
Source: ccextractor-dmo
Section: utils
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://ccextractor.org/
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), libpng-dev, quilt, libavfilter-dev,
 libleptonica-dev (>= 1.73~), libtesseract-dev (>= 4.00~), libutf8proc-dev,
 libcurl4-gnutls-dev, libfreetype-dev, libprotobuf-c-dev, pkg-config, libgpac-dev

## GUI
## libglfw3-dev, libglew-dev

Package: ccextractor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: fast closed captions extractor for MPEG and H264 files
 Supports DVD, HDTV transport streams, Replay TV.
 .
 Use this to create .srt (subtitles) files for your TV captures,
 have transcripts so you can edit subtitles, etc.

#Package: ccextractor-gui
#Architecture: any
#Depends: ccextractor (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, fonts-roboto-hinted
#Description: fast closed captions extractor for MPEG and H264 files
# Supports DVD, HDTV transport streams, Replay TV.
# .
# Use this to create .srt (subtitles) files for your TV captures,
# have transcripts so you can edit subtitles, etc.
# .
# This package contains the graphic user interface.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with quilt -Dlinux

override_dh_autoreconf:
	cd linux && ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- \
	--enable-hardsubx

#	exit 1

override_dh_clean:
	dh_clean linux/Makefile.in linux/aclocal.m4 linux/build-conf/compile \
	linux/build-conf/depcomp linux/build-conf/install-sh linux/build-conf/missing \
	linux/configure src/lib_ccx/compile_info.h

#	find -name .dirstamp -delete

	rm -rf windows
	rm -rf fonts

	rm -rf src/thirdparty/freetype
	rm -rf src/thirdparty/gpacmp4
	rm -rf src/thirdparty/libpng
	rm -rf src/thirdparty/protobuf-c
	rm -rf src/thirdparty/utf8proc
	rm -rf src/thirdparty/zlib

=== debian/watch ===
version=4

opts="dversionmangle=s/\+ds\d*$//" \
https://github.com/CCExtractor/ccextractor/releases \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@

## ccextractor-dmo 0.94

=== debian/changelog ===
ccextractor-dmo (1:0.94-dmo9~bpo13+1) trixie-backports; urgency=medium

  * Upload to stable-backports (Build with ffmpeg 8)

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 16 Oct 2025 08:32:18 +0200

ccextractor-dmo (1:0.94-dmo9) unstable; urgency=medium

  * Build with libleptonica6

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 06 Oct 2024 08:49:55 +0200

ccextractor-dmo (1:0.94-dmo8) unstable; urgency=medium

  * Build with ffmpeg 7.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 06 Apr 2024 13:41:37 +0200

ccextractor-dmo (1:0.94-dmo7) unstable; urgency=medium

  * Rebuild for time_t

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 Mar 2024 11:01:24 +0100

ccextractor-dmo (1:0.94-dmo6) unstable; urgency=medium

  * Build with libutf8proc3

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 28 Oct 2023 01:26:08 +0200

ccextractor-dmo (1:0.94-dmo5) unstable; urgency=medium

  * Add Debian patches to fix build with ffmpeg 6

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 19 Aug 2023 09:50:59 +0200

ccextractor-dmo (1:0.94-dmo4) unstable; urgency=medium

  * Build with libgpac12

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 20 Dec 2022 13:43:32 +0100

ccextractor-dmo (1:0.94-dmo3) unstable; urgency=medium

  * Build with libtesseract5

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 04 Jun 2022 07:26:53 +0200

ccextractor-dmo (1:0.94-dmo2) unstable; urgency=medium

  * Build with libgpac11

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Feb 2022 14:39:16 +0100

ccextractor-dmo (1:0.94-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 15 Dec 2021 12:04:39 +0100

ccextractor-dmo (1:0.93-dmo2) unstable; urgency=medium

  * Build with libgpac-dev instead of included gpac.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 07 Oct 2021 15:34:14 +0200

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,16 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://ccextractor.org/
-Standards-Version: 4.5.1
+Rules-Requires-Root: no
+Standards-Version: 4.7.0
 Build-Depends: debhelper-compat (= 13), libpng-dev, quilt, libavfilter-dev,
- libleptonica-dev (>= 1.73~), libtesseract-dev (>= 4.00~), libutf8proc-dev,
- libcurl4-gnutls-dev, libfreetype-dev, libprotobuf-c-dev, pkg-config, libgpac-dev
-
-## GUI
-## libglfw3-dev, libglew-dev
+ libleptonica-dev (>= 1.81~), libtesseract-dev (>= 5.3~), libutf8proc-dev (>= 2.9~),
+ libcurl4-gnutls-dev, libfreetype-dev, libprotobuf-c-dev (>= 1.4.1~), pkgconf,
+ libgpac-dev, tesseract-ocr,
 
 Package: ccextractor
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends},
 Description: fast closed captions extractor for MPEG and H264 files
  Supports DVD, HDTV transport streams, Replay TV.
  .

=== debian/rules ===
--- 
+++ 
@@ -8,20 +8,23 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	--enable-hardsubx
+	--enable-hardsubx \
+	--without-rust
 
 #	exit 1
 
 override_dh_clean:
 	dh_clean linux/Makefile.in linux/aclocal.m4 linux/build-conf/compile \
 	linux/build-conf/depcomp linux/build-conf/install-sh linux/build-conf/missing \
-	linux/configure src/lib_ccx/compile_info.h
+	linux/configure src/lib_ccx/compile_info.h linux/build-conf/config.guess \
+	linux/build-conf/config.sub
 
 #	find -name .dirstamp -delete
 
 	rm -rf windows
 	rm -rf fonts
 
+# Uses system libraries instead.
 	rm -rf src/thirdparty/freetype
 	rm -rf src/thirdparty/gpacmp4
 	rm -rf src/thirdparty/libpng

=== debian/watch ===
version=4

opts="dversionmangle=s/\+ds\d*$//" \
https://github.com/CCExtractor/ccextractor/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@

## ccextractor-dmo 0.96.4

=== OpenBSD/Makefile ===
# $OpenBSD$

MAINTAINER = 	Marc Espie <espie@openbsd.org>
CATEGORIES =	multimedia
COMMENT =	closed caption subtitles extractor
HOMEPAGE = 	https://ccextractor.org
V =		0.96.4
DISTFILES =	ccextractor.${V:S/.//}-src.zip
MASTER_SITES =	${MASTER_SITE_SOURCEFORGE:=ccextractor/}
DISTNAME =	ccextractor-$V
WRKDIST =	${WRKDIR}/ccextractor.$V
WRKSRC =	${WRKDIST}/src

# GPL 2.0
PERMIT_DISTFILES_CDROM =	Yes
PERMIT_PACKAGE_CDROM =		Yes
PERMIT_DISTFILES_FTP =		Yes
PERMIT_PACKAGE_FTP =		Yes

DOCDIR = 	${PREFIX}/share/doc/ccextractor
do-configure:
	ln -s ${FILESDIR}/Makefile ${WRKSRC}/Makefile

do-install:
	${INSTALL_PROGRAM} ${WRKBUILD}/ccextractor ${PREFIX}/bin
	${INSTALL_DATA_DIR} ${DOCDIR}
	for i in ${WRKDIST}/docs/*.TXT; do \
		${INSTALL_DATA} $$i ${DOCDIR}; \
	done

WANTLIB +=	c m stdc++ 

.include <bsd.port.mk>

=== debian/changelog ===
ccextractor-dmo (1:0.96.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 01 Jan 2026 13:13:46 +0100

ccextractor-dmo (1:0.94-dmo10) unstable; urgency=medium

  * Build with ffmpeg 8

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 31 Aug 2025 16:36:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: ccextractor-dmo
 Section: utils
-Priority: optional
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://ccextractor.org/
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Build-Depends: debhelper-compat (= 13), libpng-dev, quilt, libavfilter-dev,
- libleptonica-dev (>= 1.81~), libtesseract-dev (>= 5.3~), libutf8proc-dev (>= 2.9~),
- libcurl4-gnutls-dev, libfreetype-dev, libprotobuf-c-dev (>= 1.4.1~), pkgconf,
- libgpac-dev, tesseract-ocr,
+ libleptonica-dev (>= 1.81~), libtesseract-dev (>= 5.3~), libcurl4-gnutls-dev,
+ libutf8proc-dev (>= 2.9~), libfreetype-dev, pkgconf, libavdevice-dev, clang,
+ cargo, libxcb-shm0-dev, libx11-dev, libgpac-dev,
 
 Package: ccextractor
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,21 @@
 #!/usr/bin/make -f
 
+export CARGO_HOME=/tmp
+
 %:
-	dh $@ --with quilt -Dlinux
-
-override_dh_autoreconf:
-	cd linux && ./autogen.sh
+	dh $@ --with quilt --without dh_autoreconf -Dlinux
 
 override_dh_auto_configure:
-	dh_auto_configure -- \
-	--enable-hardsubx \
-	--without-rust
+
+#	dh_auto_configure -- \
+#	--enable-ocr \
+#	--enable-hardsubx \
+#	--without-rust
 
 #	exit 1
+
+execute_before_dh_auto_build:
+	cd linux && ./build -system-libs -hardsubx
 
 override_dh_clean:
 	dh_clean linux/Makefile.in linux/aclocal.m4 linux/build-conf/compile \

## ccextractor-dmo 0.96.5

=== OpenBSD/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 CATEGORIES =	multimedia
 COMMENT =	closed caption subtitles extractor
 HOMEPAGE = 	https://ccextractor.org
-V =		0.96.4
+V =		0.96.5
 DISTFILES =	ccextractor.${V:S/.//}-src.zip
 MASTER_SITES =	${MASTER_SITE_SOURCEFORGE:=ccextractor/}
 DISTNAME =	ccextractor-$V

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.24.0)
project (CCExtractor)

include (CTest)

option (WITH_FFMPEG "Build using FFmpeg demuxer and decoder" OFF)
option (WITH_OCR "Build with OCR (Optical Character Recognition) feature" OFF)
option (WITH_HARDSUBX "Build with support for burned-in subtitles" OFF)

# Version number
set (CCEXTRACTOR_VERSION_MAJOR 0)
set (CCEXTRACTOR_VERSION_MINOR 89)

# Get project directory
get_filename_component(BASE_PROJ_DIR ../ ABSOLUTE)

# Get the latest commit hash of the working branch
IF(EXISTS "${BASE_PROJ_DIR}/.git")
    execute_process(
            COMMAND git rev-parse HEAD
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_COMMIT_HASH
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )
ELSE(EXISTS "${BASE_PROJ_DIR}/.git")
    set(GIT_BRANCH "Unknown")
    set(GIT_COMMIT_HASH "Unknown")
ENDIF(EXISTS "${BASE_PROJ_DIR}/.git")

#Get the date
string(TIMESTAMP COMPILATION_DATE %Y-%m-%d)

message(STATUS "Commit : ${GIT_COMMIT_HASH}")
message(STATUS "Compilation Date: ${COMPILATION_DATE}")

# configure a header file to pass some of the CMake settings
# to the source code
configure_file (
  "${PROJECT_SOURCE_DIR}/CCExtractorConfig.h.in"
  "${PROJECT_SOURCE_DIR}/lib_ccx/compile_info_real.h"
  )

add_definitions(-DVERSION_FILE_PRESENT -DFT2_BUILD_LIBRARY -DGPAC_DISABLE_VTT -DGPAC_DISABLE_OD_DUMP -DGPAC_DISABLE_REMOTERY -DNO_GZIP)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  add_definitions(-DGPAC_64_BITS)
endif()

include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR}/lib_ccx)
include_directories(${PROJECT_SOURCE_DIR}/lib_ccx/zvbi)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/lib_hash)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/libpng)

# Check if the operating system is macOS (Darwin)
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  if(${CMAKE_HOST_SYSTEM_PROCESSOR} MATCHES "arm64")
    # ARM Macs
    include_directories("/opt/homebrew/include")
    include_directories(${PROJECT_SOURCE_DIR}/thirdparty/libpng/arm)
    aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/libpng/arm SOURCEFILE)
  else()
    include_directories("/usr/local/include")
  endif()
endif()

include_directories(${PROJECT_SOURCE_DIR}/thirdparty/zlib)
include_directories(${PROJECT_SOURCE_DIR}/thirdparty/freetype/include)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/lib_hash/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/libpng/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/thirdparty/zlib/ SOURCEFILE)
aux_source_directory(${PROJECT_SOURCE_DIR}/lib_ccx/zvbi/ SOURCEFILE)

set(UTF8PROC_SOURCE ${PROJECT_SOURCE_DIR}/thirdparty/utf8proc/utf8proc.c)

set(FREETYPE_SOURCE
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/autofit/autofit.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbase.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbbox.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbdf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftbitmap.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftcid.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftfntfmt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftfstype.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftgasp.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftglyph.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftgxval.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftinit.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftlcdfil.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftmm.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftotval.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftpatent.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftpfr.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftstroke.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftsynth.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftsystem.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/fttype1.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/base/ftwinfnt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/bdf/bdf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/bzip2/ftbzip2.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cache/ftcache.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cff/cff.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/cid/type1cid.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/gzip/ftgzip.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/lzw/ftlzw.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pcf/pcf.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pfr/pfr.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/psaux/psaux.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/pshinter/pshinter.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/psnames/psnames.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/raster/raster.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/sfnt/sfnt.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/smooth/smooth.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/truetype/truetype.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/type1/type1.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/type42/type42.c
        ${PROJECT_SOURCE_DIR}/thirdparty/freetype/winfonts/winfnt.c
        )
#Windows specific libraries and linker flags
if(WIN32)
    if(NOT MINGW)
        include_directories ("${PROJECT_SOURCE_DIR}/thirdparty/win_spec_incld/")
    endif()
    include_directories ("${PROJECT_SOURCE_DIR}/thirdparty/win_iconv/")
    aux_source_directory ("${PROJECT_SOURCE_DIR}/thirdparty/win_iconv/" SOURCEFILE)
    set (EXTRA_LIBS ${EXTRA_LIBS} ws2_32 winmm Bcrypt)
else (WIN32)
    # Adding some platform specific library path
    if(UNIX AND NOT APPLE)
        link_directories (/usr/local/lib)
    endif()

    if(APPLE)
        # Homebrew library paths
        link_directories(/usr/local/lib)
        link_directories(/opt/homebrew/lib)
    endif()
endif(WIN32)

if(MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3 /wd4005 /wd4996")
else (MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-write-strings -g -std=gnu99")
endif(MSVC)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
add_subdirectory (lib_ccx)

aux_source_directory(${PROJECT_SOURCE_DIR} SOURCEFILE)
set (EXTRA_LIBS ${EXTRA_LIBS} ccx)
set (EXTRA_LIBS ${EXTRA_LIBS} ${GPAC_LIBRARIES})
# set (EXTRA_LIBS ${EXTRA_LIBS} m)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set (EXTRA_LIBS ${EXTRA_LIBS} iconv)
endif (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")


set (EXTRA_LIBS ${EXTRA_LIBS} -lm -lpthread -ldl)

find_package (PkgConfig)

########################################################
# Build using FFmpeg libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_FFMPEG)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)
  pkg_check_modules (AVFILTER REQUIRED libavfilter)
  pkg_check_modules (SWSCALE REQUIRED libswscale)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (PKG_CONFIG_FOUND AND WITH_FFMPEG)

########################################################
# Build with OCR using leptonica and tesseract libraries
########################################################

if (PKG_CONFIG_FOUND AND WITH_OCR)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
endif (PKG_CONFIG_FOUND AND WITH_OCR)

########################################################
# Build for hardsubx using avformat, avutil, avcodec and
# swscale
########################################################

if (PKG_CONFIG_FOUND AND WITH_HARDSUBX)

  pkg_check_modules (AVFORMAT REQUIRED libavformat)
  pkg_check_modules (AVUTIL REQUIRED libavutil)
  pkg_check_modules (AVCODEC REQUIRED libavcodec)
  pkg_check_modules (AVFILTER REQUIRED libavfilter)
  pkg_check_modules (SWSCALE REQUIRED libswscale)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${TESSERACT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${LEPTONICA_INCLUDE_DIRS})
endif (PKG_CONFIG_FOUND AND WITH_HARDSUBX)

add_executable (ccextractor ${SOURCEFILE} ${FREETYPE_SOURCE} ${UTF8PROC_SOURCE})

########################################################
# Build with Rust library
########################################################

if (PKG_CONFIG_FOUND)
  add_subdirectory (rust)
  set (EXTRA_LIBS ${EXTRA_LIBS} ccx_rust)
endif (PKG_CONFIG_FOUND)


target_link_libraries (ccextractor ${EXTRA_LIBS})
target_include_directories (ccextractor PUBLIC ${EXTRA_INCLUDES})

install (TARGETS ccextractor DESTINATION bin)

=== src/lib_ccx/CMakeLists.txt ===
cmake_policy (SET CMP0037 NEW)

if(MSVC)
    set (CMAKE_C_FLAGS "-W3 /wd4005 /wd4996")
else (MSVC)
    set (CMAKE_C_FLAGS "-Wall -Wno-pointer-sign -g -std=gnu99")
endif(MSVC)

if(WIN32)
    add_definitions(-DWIN32)
endif(WIN32)

find_package(PkgConfig)
pkg_check_modules (GPAC REQUIRED gpac)

set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${GPAC_INCLUDE_DIRS})
set (EXTRA_LIBS ${EXTRA_LIBS} ${GPAC_LIBRARIES})

if (WITH_FFMPEG)
    find_package(PkgConfig)

    pkg_check_modules (AVFORMAT REQUIRED libavformat)
    pkg_check_modules (AVUTIL REQUIRED libavutil)
    pkg_check_modules (AVCODEC REQUIRED libavcodec)
    pkg_check_modules (AVFILTER REQUIRED libavfilter)
    pkg_check_modules (SWSCALE REQUIRED libswscale)

    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_FFMPEG")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (WITH_FFMPEG)

if (WITH_OCR)
  find_package(PkgConfig)

  pkg_check_modules (TESSERACT REQUIRED tesseract)
  pkg_check_modules (LEPTONICA REQUIRED lept)

  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${TESSERACT_INCLUDE_DIRS})
  set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${LEPTONICA_INCLUDE_DIRS})

  set (EXTRA_LIBS ${EXTRA_LIBS} ${TESSERACT_LIBRARIES})
  set (EXTRA_LIBS ${EXTRA_LIBS} ${LEPTONICA_LIBRARIES})

  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_OCR")
endif (WITH_OCR)


aux_source_directory ("${PROJECT_SOURCE_DIR}/lib_ccx/" SOURCEFILE)

add_library (ccx ${SOURCEFILE} ccx_dtvcc.h ccx_dtvcc.c ccx_encoders_mcc.c ccx_encoders_mcc.h)
target_link_libraries (ccx ${EXTRA_LIBS})
target_include_directories (ccx PUBLIC ${EXTRA_INCLUDES})

if (WITH_HARDSUBX)
    find_package(PkgConfig)

    pkg_check_modules (AVFORMAT REQUIRED libavformat)
    pkg_check_modules (AVUTIL REQUIRED libavutil)
    pkg_check_modules (AVCODEC REQUIRED libavcodec)
    pkg_check_modules (AVFILTER REQUIRED libavfilter)
    pkg_check_modules (SWSCALE REQUIRED libswscale)

    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFORMAT_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVUTIL_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVCODEC_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${AVFILTER_LIBRARIES})
    set (EXTRA_LIBS ${EXTRA_LIBS} ${SWSCALE_LIBRARIES})

    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFORMAT_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVUTIL_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVCODEC_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${AVFILTER_INCLUDE_DIRS})
    set (EXTRA_INCLUDES ${EXTRA_INCLUDES} ${SWSCALE_INCLUDE_DIRS})

    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DENABLE_HARDSUBX")
endif (WITH_HARDSUBX)

file (GLOB HeaderFiles *.h)
file (WRITE ccx.pc "prefix=${CMAKE_INSTALL_PREFIX}\n"
                  "includedir=\${prefix}/include\n"
                  "libdir=\${prefix}/lib\n\n"
                  "Name: ccx\n"
                  "Description: Closed Caption Extraction library\n"
                  "Version: 0.75\n"
                  "Cflags: -I\${includedir}/\n"
                  "Libs: -L\${libdir} -lccx -lpng\n"
                  "Libs.private: -lpng\n"
                  )

install (TARGETS ccx DESTINATION lib)
install (FILES ${HeaderFiles} DESTINATION include)
install (FILES ccx.pc DESTINATION lib/pkgconfig)

=== src/rust/CMakeLists.txt ===
include(FetchContent)
FetchContent_Declare(
    Corrosion
    GIT_REPOSITORY https://github.com/corrosion-rs/corrosion.git
    GIT_TAG v0.5.1
    FIND_PACKAGE_ARGS
)
FetchContent_MakeAvailable(Corrosion)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(PROFILE "dev")
else()
    set(PROFILE "release")
endif()

if(WITH_OCR AND WITH_HARDSUBX)
    set(FEATURES "hardsubx_ocr")
else()
    set(FEATURES "")
endif()

# Check rust version
set(MSRV "1.87.0")
if(Rust_VERSION VERSION_GREATER_EQUAL ${MSRV})
    message(STATUS "rustc >= MSRV(${MSRV})")
else()
    message(FATAL_ERROR "Minimum supported rust version(MSRV) is ${MSRV}, please upgrade rust")
endif(Rust_VERSION VERSION_GREATER_EQUAL ${MSRV})

corrosion_import_crate(
    MANIFEST_PATH Cargo.toml
    PROFILE ${PROFILE}
    FEATURES ${FEATURES}
)

add_test(
    NAME ccx_rust_test
    COMMAND $<TARGET_FILE:Rust::Cargo> test
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
ccextractor-dmo (1:0.96.5-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 06 Jan 2026 01:46:36 +0100

=== debian/control ===
--- 
+++ 
@@ -17,14 +17,3 @@
  .
  Use this to create .srt (subtitles) files for your TV captures,
  have transcripts so you can edit subtitles, etc.
-
-#Package: ccextractor-gui
-#Architecture: any
-#Depends: ccextractor (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, fonts-roboto-hinted
-#Description: fast closed captions extractor for MPEG and H264 files
-# Supports DVD, HDTV transport streams, Replay TV.
-# .
-# Use this to create .srt (subtitles) files for your TV captures,
-# have transcripts so you can edit subtitles, etc.
-# .
-# This package contains the graphic user interface.

=== debian/rules ===
#!/usr/bin/make -f

export CARGO_HOME=/tmp

%:
	dh $@ --with quilt --without dh_autoreconf -Dlinux

execute_before_dh_auto_build:
	cd linux && ./build -system-libs -hardsubx 

override_dh_clean:
	dh_clean linux/Makefile.in linux/aclocal.m4 linux/build-conf/compile \
	linux/build-conf/depcomp linux/build-conf/install-sh linux/build-conf/missing \
	linux/configure src/lib_ccx/compile_info.h linux/build-conf/config.guess \
	linux/build-conf/config.sub

override_dh_auto_configure:

## ccextractor-dmo 0.96.6

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 # Version number
 set (CCEXTRACTOR_VERSION_MAJOR 0)
-set (CCEXTRACTOR_VERSION_MINOR 89)
+set (CCEXTRACTOR_VERSION_MINOR 96)
 
 # Get project directory
 get_filename_component(BASE_PROJ_DIR ../ ABSOLUTE)
@@ -255,4 +255,13 @@
 target_link_libraries (ccextractor ${EXTRA_LIBS})
 target_include_directories (ccextractor PUBLIC ${EXTRA_INCLUDES})
 
+# ccx_rust (Rust) calls C functions from ccx (like decode_vbi).
+# Force the linker to pull these symbols from ccx before processing ccx_rust.
+if (NOT WIN32 AND NOT APPLE)
+  target_link_options (ccextractor PRIVATE
+    -Wl,--undefined=decode_vbi
+    -Wl,--undefined=do_cb
+    -Wl,--undefined=store_hdcc)
+endif()
+
 install (TARGETS ccextractor DESTINATION bin)

=== tests/Makefile ===
SHELL = /bin/sh

CC=gcc
# SYS := $(shell gcc -dumpmachine)
CFLAGS=-O0 -std=gnu99 -D ENABLE_OCR -g -ggdb -rdynamic
#-Q -da -v

# enable COVERAGE
# CFLAGS+=-fprofile-arcs -ftest-coverage

# add debug flag
ifdef DEBUG
CFLAGS+=-DDEBUG
endif

#ALL_FLAGS = -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DVERSION_FILE_PRESENT
LDFLAGS=-lm -g -lgpac

CFLAGS+=$(shell pkg-config --cflags check)
LDFLAGS+=$(shell pkg-config --libs check)

# TODO: need to rewrite this. Need new way to load sources for testing
OBJS=$(filter-out ../linux/objs/ccextractor.o, $(wildcard ../linux/objs/*.o))

SRC_SUITE=$(wildcard *_suite.c)
OBJ_SUITE=$(patsubst %_suite.c, %_suite.o, $(SRC_SUITE))

OBJS+=$(OBJ_SUITE)

all: clean test

%.o: %.c
	# explicit output name :  -o $@
	$(CC) -c $(ALL_FLAGS) $(CFLAGS) $<

runtest: $(OBJS)
	@echo "+----------------------------------------------+"
	@echo "|                 BUILD TESTS                  |"
	@echo "+----------------------------------------------+"
	$(CC) -c $(ALL_FLAGS) $(CFLAGS) $@.c
	$(CC) $@.o $^ $(ALL_FLAGS) $(CFLAGS) $(LDFLAGS) -o $@

.PHONY: test
test: runtest
	@echo "+----------------------------------------------+"
	@echo "|                 START TESTS                  |"
	@echo "+----------------------------------------------+"
	./runtest

.PHONY: clean
clean:
	rm runtest || true
	rm *.o || true
	# coverage info
	rm *.gcda || true
	rm *.gcno || true
	# debug info
	rm *.c.* || true

=== src/lib_ccx/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 cmake_policy (SET CMP0037 NEW)
 
 if(MSVC)
-    set (CMAKE_C_FLAGS "-W3 /wd4005 /wd4996")
+    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3 /wd4005 /wd4996")
 else (MSVC)
-    set (CMAKE_C_FLAGS "-Wall -Wno-pointer-sign -g -std=gnu99")
+    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-pointer-sign -g -std=gnu99")
 endif(MSVC)
 
 if(WIN32)

=== debian/changelog ===
ccextractor-dmo (1:0.96.6-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 20 Feb 2026 08:36:59 +0100

ccextractor-dmo (1:0.96.5-dmo2) unstable; urgency=medium

  * Build with libgpac16

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 05 Feb 2026 17:09:25 +0100

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,7 @@
 	linux/configure src/lib_ccx/compile_info.h linux/build-conf/config.guess \
 	linux/build-conf/config.sub
 
+override_dh_installchangelogs:
+	dh_installchangelogs docs/CHANGES.TXT
+
 override_dh_auto_configure:
